<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Filtering for log records."><meta name="keywords" content="rust, rustlang, rust-lang, filter"><title>env_logger::filter - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/static/images/favicon.ico"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../env_logger/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../env_logger/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module filter</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../env_logger/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">env_logger</a>::<wbr><a class="mod" href="#">filter</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/env_logger/filter/mod.rs.html#1-868">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Filtering for log records.</p>
<p>This module contains the log filtering used by <code>env_logger</code> to match records.
You can use the <code>Filter</code> type in your own logger implementation to use the same
filter parsing and matching as <code>env_logger</code>. For more details about the format
for directive strings see <a href="../index.html#enabling-logging">Enabling Logging</a>.</p>
<h3 id="using-env_logger-in-your-own-logger"><a href="#using-env_logger-in-your-own-logger">Using <code>env_logger</code> in your own logger</a></h3>
<p>You can use <code>env_logger</code>’s filtering functionality with your own logger.
Call <a href="struct.Builder.html#method.parse"><code>Builder::parse</code></a> to parse directives from a string when constructing
your logger. Call <a href="struct.Filter.html#method.matches"><code>Filter::matches</code></a> to check whether a record should be
logged based on the parsed filters when log records are received.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">log</span>;
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">env_logger</span>;
<span class="kw">use</span> <span class="ident">env_logger::filter::Filter</span>;
<span class="kw">use</span> <span class="ident">log</span>::{<span class="ident">Log</span>, <span class="ident">Metadata</span>, <span class="ident">Record</span>};

<span class="kw">struct</span> <span class="ident">MyLogger</span> {
    <span class="ident">filter</span>: <span class="ident">Filter</span>
}

<span class="kw">impl</span> <span class="ident">MyLogger</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">MyLogger</span> {
        <span class="kw">use</span> <span class="ident">env_logger::filter::Builder</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">builder</span> <span class="op">=</span> <span class="ident">Builder::new</span>();

        <span class="comment">// Parse a directives string from an environment variable</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="kw-2">ref</span> <span class="ident">filter</span>) <span class="op">=</span> <span class="ident">std::env::var</span>(<span class="string">&quot;MY_LOG_LEVEL&quot;</span>) {
           <span class="ident">builder</span>.<span class="ident">parse</span>(<span class="ident">filter</span>);
        }

        <span class="ident">MyLogger</span> {
            <span class="ident">filter</span>: <span class="ident">builder</span>.<span class="ident">build</span>()
        }
    }
}

<span class="kw">impl</span> <span class="ident">Log</span> <span class="kw">for</span> <span class="ident">MyLogger</span> {
    <span class="kw">fn</span> <span class="ident">enabled</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">metadata</span>: <span class="kw-2">&amp;</span><span class="ident">Metadata</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">filter</span>.<span class="ident">enabled</span>(<span class="ident">metadata</span>)
    }

    <span class="kw">fn</span> <span class="ident">log</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) {
        <span class="comment">// Check if the record is matched by the filter</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">filter</span>.<span class="ident">matches</span>(<span class="ident">record</span>) {
            <span class="macro">println!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">record</span>);
        }
    }

    <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {}
}</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Builder.html" title="env_logger::filter::Builder struct">Builder</a></div><div class="item-right docblock-short"><p>A builder for a log filter.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Filter.html" title="env_logger::filter::Filter struct">Filter</a></div><div class="item-right docblock-short"><p>A log filter.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="env_logger" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>